/*!
 * © 2021 David Vines
 *
 * Creative Commons License
 *
 * This work is licensed under a Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License.
 */

/* exported Move */
class Move {
	constructor(name,ourStatFunction,theirStatFunction) {
		this._name = name;
		this._thac0 = {};
		this._ourStatFunction = ourStatFunction;
		this._theirStatFunction = theirStatFunction;
	}
	addCounterMove(move,thac0) {
		this._thac0[move.toString()] = thac0;
	}
	toString() {
		return this._name;
	}
	getOdds(theirMove,us,them) {
		const diff = this._ourStatFunction.call(us) - this._theirStatFunction.call(them);
		const thac0 = this._thac0[theirMove.toString()]-1;
		const adjthac0 = thac0 - diff/5;

		return 5*(21-adjthac0);
	}
}